<template>
  <q-table
    ref="tableRef"
    title="Inscriptos"
    :dense="true"
    :rows="dataSet"
    :columns="columnas"
    row-key="uuid"
    wrap-cells
    v-model:pagination="FormacionParticipantesStore.filtros"
    :loading="loading"
    binary-state-sort
    @request="onPaginar"
  >
    <!--------------------------------------
            loading
          ---------------------------------------->
    <template v-slot:loading>
      <Loading showing />
    </template>

    <!--------------------------------------
            Btn Exportacion
          ---------------------------------------->
    <template v-slot:top-left>
      <div class="q-col-gutter-md row">
        <q-input
          dense
          placeholder="Buscar ..."
          v-model="FormacionParticipantesStore.filtros.query"
          debounce="300"
        >
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>

        <q-btn color="green" flat label="Filtrar" @click="onRequest" />
      </div>
      <!-- Filtrasr
         tipo => Adultos y Beneficarios.
         rama => en eventos de programa, que permista filtrar la rama en que se anoto
         Otra zona / otro distrito
         por dieta
         -->
    </template>
    <template v-slot:no-data>Sin Inscriptos</template>
    <!--
    <template v-slot:top-right>
      <div class="q-pa-sm">
        <q-btn-group outline class="q-gutter-sm"> Botonera export ! </q-btn-group>
      </div>
    </template>
    -->

    <!--------------------------------------
            Columnas
          ---------------------------------------->

    <template v-slot:body-cell-datos="props">
      <q-td :props="props">
        <PersonaDetalle :persona="props.row.persona"></PersonaDetalle>
      </q-td>
    </template>

    <template v-slot:body-cell-rama="props">
      <q-td :props="props">
        <ItemRama :rama="props.row.rama" />
      </q-td>
    </template>

    <template v-slot:body-cell-funcion="props">
      <q-td :props="props">
        <PersonasFunciones :funciones="props.row.persona.funciones" />
      </q-td>
    </template>

    <template v-slot:body-cell-estado="props">
      <q-td :props="props">
        <EstadoExperiencia :estado="props.row.estado_id" />
      </q-td>
    </template>

    <template v-slot:body-cell-opciones="props">
      <q-td :props="props">
        <div class="q-pa-md q-gutter-sm">
          <q-btn @click="estadoEditar(props.row)" size="sm" flat color="blue">
            Editar
          </q-btn>
        </div>
      </q-td>
    </template>
  </q-table>

  <DialogEditarPartial v-model="estadoEditando" @close="estadoCerrarDialog" />
</template>

<script lang="ts">
import { defineComponent, onMounted, ref, toRef, PropType, watch } from 'vue';
import { QTableProps } from 'quasar';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import { useFormacionParticipantesStore } from 'src/stores/formacion/participantes';
import { useRoute } from 'vue-router';
import PersonaDetalle from 'components/Personas/Detalle.vue';
import PersonasFunciones from 'components/Personas/Funciones.vue';
import EstadoExperiencia from 'src/components/Formacion/EstadoExperiencia.vue';
import {
  ExperienciaInterface,
  FormacionParticipantesInterface,
} from 'src/interfaces/FormacionInterface';
import ItemRama from 'components/Util/ItemRama.vue';
import Loading from 'src/components/Loading.vue';
import DialogEditarPartial from './_DialogEditarPartial.vue';

export default defineComponent({
  name: 'ListadoParticipantesPartial',
  props: {
    experiencia: {
      type: Object as PropType<ExperienciaInterface | undefined>,
      required: true,
    },
  },

  components: {
    Loading,
    PersonaDetalle,
    PersonasFunciones,
    EstadoExperiencia,
    ItemRama,
    DialogEditarPartial,
  },

  setup(props) {
    const tableRef = ref();

    const loading = ref(true);
    const FormacionParticipantesStore = useFormacionParticipantesStore();
    const route = useRoute();
    const uuid = String(route.params.uuid);

    onMounted(() => {
      setColumnas();
      FormacionParticipantesStore.inicializar(); // esto lo hago para que no se tome los datos guardados de otro evento detalle
      FormacionParticipantesStore.filtros.evento_uuid = uuid;
      // get initial data from server (1st page)
      tableRef.value.requestServerInteraction();
    });

    const expe = toRef(props, 'experiencia');
    watch(expe, (newValue) => {
      if (newValue !== undefined) {
        setColumnas();
      }
    });

    const columnas = ref<QTableProps['columns']>();
    function setColumnas() {
      // Defino las columnas de la tabla
      columnas.value = [
        { name: 'datos', label: 'Datos', field: 'datos', align: 'left' },
        {
          name: 'funcion',
          label: 'Funciones',
          field: 'funcion',
          align: 'left',
        },

        { name: 'estado', label: 'Estado', field: 'estado', align: 'left' },
        {
          name: 'opciones',
          label: 'Opciones',
          field: 'opciones',
          align: 'left',
        },
      ];

      if (columnas.value[2].name != 'rama') {
        columnas.value.splice(1, 0);
      }

      if (props.experiencia?.solicita_rama) {
        /// arr.splice(index, 0, item);
        columnas.value.splice(2, 0, {
          name: 'rama',
          label: 'Rama Cursa',
          field: 'rama',
          align: 'left',
        });
      }
    }

    /*********************************************
     *  Modal Cambio Estado
     */
    const estadoEditando = ref();
    function estadoEditar(participante: FormacionParticipantesInterface) {
      estadoEditando.value = participante;
    }
    function estadoCerrarDialog() {
      estadoEditando.value = {};
    }

    ////////////////////////////////////////////////////////////////////////////////
    //            GESTION DE PAGINADO Y GESTION DE DATOS
    ////////////////////////////////////////////////////////////////////////////////
    /*********************************************
     *  Metodo onPaginar
     *  Gestiona la configuracion del paginado.
     */
    function onPaginar(props: QTableProps) {
      FormacionParticipantesStore.setPaginar(props);
      onRequest();
    }

    function onFiltrar() {
      FormacionParticipantesStore.filtroActivado = true;
      FormacionParticipantesStore.filtros.page = 1; // siempre que vuelvo a filtra, vuelvo a la pagina 1.
      onRequest();
    }

    /*********************************************
     *  Metoto onRequest
     *  encargado de obtener los datos desde la API
     */
    const dataSet = ref<FormacionParticipantesInterface[]>();
    function onRequest() {
      loading.value = true;
      api
        .get('/api/formacion/participantes', {
          params: {
            ...FormacionParticipantesStore.parametros,
            curso_uuid: uuid,
          },
        })
        .then((response: AxiosResponse) => {
          FormacionParticipantesStore.setRowTotal(response.data.count); // Actializo la cantidas de row, por si cambio
          dataSet.value = response.data.data;
          loading.value = false;
        })
        .finally(() => {
          loading.value = false;
        });
    }

    /*********************************************
     *  Metoto resetFiltros
     *  Reinilizo los Filtros
     */
    function onResetFiltros() {
      FormacionParticipantesStore.resetFiltros();
      // getCombosEquipos();
      // Recargo la info de la pagina !
      onRequest();
    }

    return {
      tableRef,
      columnas,
      dataSet,
      FormacionParticipantesStore,
      onRequest,
      onPaginar,
      onResetFiltros,
      onFiltrar,
      loading,

      estadoEditando,
      estadoEditar,
      estadoCerrarDialog,
    };
  },
});
</script>
